with GNATCOM.Dispinterface;

package MSHTML.IHTMLDOMNode_Interface is

   type IHTMLDOMNode_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IHTMLDOMNode_Type);

   function Pointer (This : IHTMLDOMNode_Type)
     return Pointer_To_IHTMLDOMNode;

   procedure Attach (This    : in out IHTMLDOMNode_Type;
                     Pointer : in     Pointer_To_IHTMLDOMNode);

   function Get_nodeType
     (This : IHTMLDOMNode_Type)
     return Interfaces.C.long;

   function Get_parentNode
     (This : IHTMLDOMNode_Type)
     return Pointer_To_IHTMLDOMNode;

   function hasChildNodes
     (This      : IHTMLDOMNode_Type)
     return GNATCOM.Types.VARIANT_BOOL;

   function Get_childNodes
     (This : IHTMLDOMNode_Type)
     return GNATCOM.Types.Pointer_To_IDispatch;

   function Get_attributes
     (This : IHTMLDOMNode_Type)
     return GNATCOM.Types.Pointer_To_IDispatch;

   function insertBefore
     (This     : IHTMLDOMNode_Type;
      newChild : Pointer_To_IHTMLDOMNode;
      refChild : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free     : Boolean := True)
     return Pointer_To_IHTMLDOMNode;

   function removeChild
     (This     : IHTMLDOMNode_Type;
      oldChild : Pointer_To_IHTMLDOMNode)
     return Pointer_To_IHTMLDOMNode;

   function replaceChild
     (This     : IHTMLDOMNode_Type;
      newChild : Pointer_To_IHTMLDOMNode;
      oldChild : Pointer_To_IHTMLDOMNode)
     return Pointer_To_IHTMLDOMNode;

   function cloneNode
     (This       : IHTMLDOMNode_Type;
      fDeep      : GNATCOM.Types.VARIANT_BOOL)
     return Pointer_To_IHTMLDOMNode;

   function removeNode
     (This    : IHTMLDOMNode_Type;
      fDeep   : GNATCOM.Types.VARIANT_BOOL)
     return Pointer_To_IHTMLDOMNode;

   function swapNode
     (This        : IHTMLDOMNode_Type;
      otherNode   : Pointer_To_IHTMLDOMNode)
     return Pointer_To_IHTMLDOMNode;

   function replaceNode
     (This        : IHTMLDOMNode_Type;
      replacement : Pointer_To_IHTMLDOMNode)
     return Pointer_To_IHTMLDOMNode;

   function appendChild
     (This     : IHTMLDOMNode_Type;
      newChild : Pointer_To_IHTMLDOMNode)
     return Pointer_To_IHTMLDOMNode;

   function Get_nodeName
     (This : IHTMLDOMNode_Type)
     return GNATCOM.Types.BSTR;

   procedure Put_nodeValue
     (This : IHTMLDOMNode_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_nodeValue
     (This : IHTMLDOMNode_Type)
     return GNATCOM.Types.VARIANT;

   function Get_firstChild
     (This : IHTMLDOMNode_Type)
     return Pointer_To_IHTMLDOMNode;

   function Get_lastChild
     (This : IHTMLDOMNode_Type)
     return Pointer_To_IHTMLDOMNode;

   function Get_previousSibling
     (This : IHTMLDOMNode_Type)
     return Pointer_To_IHTMLDOMNode;

   function Get_nextSibling
     (This : IHTMLDOMNode_Type)
     return Pointer_To_IHTMLDOMNode;

end MSHTML.IHTMLDOMNode_Interface;

